import { numericGreaterFirst, dictOrderGreaterFirst } from "../comparator";
import { BinaryHeap } from "../BinaryHeap";
import { PairingHeap } from "../PairingHeap";
import { SkewHeap } from "../SkewHeap";
var Ctors = [BinaryHeap, PairingHeap, SkewHeap];

var _loop = function _loop() {
  var A = _Ctors[_i];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    var _loop2 = function _loop2() {
      var B = _step.value;
      describe("".concat(A.name, " vs ").concat(B.name), function () {
        it("mergable if have same comparator", function () {
          // @ts-ignore
          var a = new A({
            comparator: numericGreaterFirst
          });
          a.push(1);
          a.push(3);
          a.push(5); // @ts-ignore

          var b = new B({
            comparator: numericGreaterFirst
          });
          b.push(2);
          b.push(4);
          b.push(6);
          expect(a.toArray()).toStrictEqual([1, 3, 5]);
          expect(b.toArray()).toStrictEqual([2, 4, 6]);
          a.merge(b);
          expect(a.toArray()).toStrictEqual([1, 2, 3, 4, 5, 6]);
          expect(b.toArray()).toStrictEqual([]);
          expect(a.pop()).toBe(6);
        });
        it("mergable even if have different comparator", function () {
          // @ts-ignore
          var a = new A({
            comparator: dictOrderGreaterFirst
          });
          a.push(1);
          a.push(10);
          a.push(100); // @ts-ignore

          var b = new B({
            comparator: numericGreaterFirst
          });
          b.push(2);
          b.push(20);
          b.push(200);
          expect(a.toArray()).toStrictEqual([1, 10, 100]);
          expect(b.toArray()).toStrictEqual([2, 20, 200]);
          a.merge(b);
          expect(a.toArray()).toStrictEqual([1, 10, 100, 2, 20, 200]);
          expect(b.toArray()).toStrictEqual([]);
          expect(a.pop()).toBe(200);
        });
      });
    };

    for (var _iterator = Ctors[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      _loop2();
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
};

for (var _i = 0, _Ctors = Ctors; _i < _Ctors.length; _i++) {
  _loop();
}